<?php

namespace Drupal\commerce_tax_rate\Resolver;

use Drupal\commerce_order\Entity\OrderItemInterface;
use Drupal\commerce_product\Entity\{ProductInterface, ProductVariationInterface};
use Drupal\commerce_tax\Resolver\{TaxRateResolverInterface, TaxTypeAwareTrait, TaxTypeAwareInterface};
use Drupal\commerce_tax\TaxZone;
use Drupal\profile\Entity\ProfileInterface;

class CommerceTaxRateResolver implements TaxRateResolverInterface, TaxTypeAwareInterface {
  use TaxTypeAwareTrait;

  /**
   * {@inheritdoc}
   */
  public function resolve(TaxZone $zone, OrderItemInterface $order_item, ProfileInterface $customer_profile) {
    $entity = $order_item->getPurchasedEntity();
    if ($entity instanceof ProductVariationInterface) {
      $product = $entity->getProduct();
      if ($product instanceof ProductInterface) {
        $product_rates = $this->taxType->getThirdPartySetting('commerce_tax_rate', 'product_tax_rates') ?? [];
        return $zone->getRate($product_rates[$zone->getId()][$product->bundle()]) ?? NULL;
      }
    }
    return NULL;
  }
}
